Option Explicit

'define the constants
const fpcBlockingPacketFilter = 2
const fpcCustomFilterType = 1
const fpcPfAnyProtocolIpIndex = 0

Const No_Error = 0

'fpcPfDirectionIndexIn (1) 
'In direction. 
'fpcPfDirectionIndexOut (2) 
'Out direction. 
'fpcPfDirectionIndexBoth (3) 
'Both directions (in and out). 
'const fpcPfDirectionIndexBoth = 1

const fpcPfDirectionIndexIn = 1
const fpcPfAnyPort = 1
const fpcPfAnyRemotePort = 1
const fpcPfDefaultProxyExternalIp = 1
const fpcPfSingleHost = 2

Main

Private Sub Main()

	On Error Resume Next

	Dim ISA
	Dim MyArray
	Dim WshShell
	Dim WshEnv
	Dim attackerIP
	Dim pf
	'Create the root object
	Set ISA = CreateObject("FPC.Root")
	ISA.Refresh

	'Get the containing array
	Set MyArray = ISA.Arrays.GetContainingArray

	' Create object to get Attacker's IP address for use in Filter name. 
	Set WshShell = WScript.CreateObject("WScript.Shell")
	Set WshEnv = WshShell.Environment("Process")

	'the environment variable 'ALERT_PARAMETER_1' contains the attacker IP
	attackerIP = WshEnv("ALERT_PARAMETER_1")
	If ChkIsIsa( attackerIP ) Then Wscript.Quit

	'see if it already exists
	Set pf = MyArray.ArrayPolicy.IpPacketFilters( "Block attacker " & attackerIP )
	If Err.Number = No_Error Then Wscript.Quit

	' Create blocking filter to all traffic from the attacker IP
	' Attacker's IP is included in filter name to allow multiple different filters to be created, otherwise only one filter blocking only the first attacker could exist. 
	Set pf = MyArray.ArrayPolicy.IpPacketFilters.Add("Block attacker " & attackerIP, fpcBlockingPacketFilter)
	pf.Description = "Block all traffic to and from the attacker at " & attackerIP

	' set the filter parameters
	pf.Enabled = True
	pf.AllServers = True
	pf.FilterType = fpcCustomFilterType
	pf.ProtocolNumber = fpcPfAnyProtocolIpIndex

	' Set direction of Packet filter 
	' pf.PacketDirection = fpcPfDirectionIndexBoth
	pf.PacketDirection = fpcPfDirectionIndexIn

	' Set applicable interface
	pf.SetLocalHost fpcPfDefaultProxyExternalIp

	' set the local and remote port type
	pf.LocalPortType = fpcPfAnyPort
	pf.RemotePortType = fpcPfAnyRemotePort

	' limit to only work with a specific attacker machine on the Internet
	pf.SetRemoteHost fpcPfSingleHost, attackerIP

	pf.Save

End Sub

'-----------------------------------------------------------
' See if "IP" belongs to the ISA server
'-----------------------------------------------------------

Function ChkIsISA(IP)

	Dim NICS, NIC, i, Msg

	ChkIsISA = False
	Const strQuery = "Select * From Win32_NetworkAdapterConfiguration where IPEnabled = True"

	Set NICS = GetObject("winmgmts:").ExecQuery(strQuery)
	If Err.Number <> 0 Then
		WScript.Echo "Error creating NICS" & Err.Description
		WScript.Quit
	End If

	For Each NIC in NICS
		If NIC is nothing Then
			WScript.echo Err.description
			WScript.Quit
		End If
		if isarray(NIC.IPAddress) then
			for i = 0 to UBound(NIC.IPAddress)
				If IP = NIC.IPAddress(i) then
					ChkIsISA = True
					Exit For
				End If
			Next
		Else
			If IP = NIC.IPAddress then ChkIsISA = True
		End If
	Next

	Err.Clear

End Function

'-vic
'vicsin.isa-geek.com
